import { ConnectOptions } from './base/connection';
import { PoolOptions } from './base/pool';
export interface LubeConfig {
    defaultConnection: string;
    defaultPool: string;
    connections: {
        [key: string]: ConnectOptions;
    };
    pools: {
        [key: string]: PoolOptions & {
            connection: string;
        };
    };
}
export declare function loadConfig(): Promise<LubeConfig>;
export declare function getDefaultConnectionOptions(): Promise<ConnectOptions>;
export declare function getConnectionOptions(key: string): Promise<ConnectOptions>;
export declare function getDefaultPoolOptions(): Promise<PoolOptions & {
    connection: ConnectOptions;
}>;
export declare function getPoolOptions(key: string): Promise<PoolOptions & {
    connection: ConnectOptions;
}>;
export declare function parseConnectionUrl(url: string): ConnectOptions;
/**
 * 准备连接选项
 */
export declare function parseConnectOption(optOrUrlOrCfg?: ConnectOptions | string): Promise<ConnectOptions>;
