"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryCompareCondition = void 0;
const expression_1 = require("../expression");
const condition_1 = require("./condition");
/**
 * 二元比较条件
 */
class BinaryCompareCondition extends condition_1.Condition {
    /**
     * 构造函数
     */
    constructor(operator, left, right) {
        super();
        this.$kind = condition_1.CONDITION_KIND.BINARY_COMPARE;
        this.$operator = operator;
        this.$left = expression_1.Expression.ensureExpression(left);
        if (Array.isArray(right)) {
            this.$right = right.map(expr => expression_1.Expression.ensureExpression(expr));
        }
        else {
            this.$right = expression_1.Expression.ensureExpression(right);
        }
    }
    static isBinaryCompareCondition(object) {
        return (condition_1.Condition.isCondition(object) &&
            object.$kind === condition_1.CONDITION_KIND.BINARY_COMPARE);
    }
}
exports.BinaryCompareCondition = BinaryCompareCondition;
