"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryLogicCondition = void 0;
const sql_1 = require("../sql");
const condition_1 = require("./condition");
/**
 * 二元逻辑查询条件条件
 */
class BinaryLogicCondition extends condition_1.Condition {
    /**
     * 创建二元逻辑查询条件实例
     */
    constructor(operator, left, right) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.CONDITION;
        this.$kind = condition_1.CONDITION_KIND.BINARY_LOGIC;
        this.$operator = operator;
        /**
         * 左查询条件
         */
        this.$left = left;
        /**
         * 右查询条件
         */
        this.$right = right;
    }
    static isBinaryLogicCondition(object) {
        return (condition_1.Condition.isCondition(object) &&
            object.$kind === condition_1.CONDITION_KIND.BINARY_LOGIC);
    }
}
exports.BinaryLogicCondition = BinaryLogicCondition;
