"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnaryCompareCondition = void 0;
const assert_1 = __importDefault(require("assert"));
const expression_1 = require("../expression");
const condition_1 = require("./condition");
/**
 * 一元比较条件
 */
class UnaryCompareCondition extends condition_1.Condition {
    /**
     * 一元比较运算符
     * @param operator 运算符
     * @param expr 查询条件
     */
    constructor(operator, expr) {
        super();
        this.$kind = condition_1.CONDITION_KIND.UNARY_COMPARE;
        this.$operator = operator;
        (0, assert_1.default)(expr, 'next must not null');
        this.$expr = expression_1.Expression.ensureExpression(expr);
    }
    static isUnaryCompareCondition(object) {
        return (condition_1.Condition.isCondition(object) &&
            object.$kind === condition_1.CONDITION_KIND.UNARY_COMPARE);
    }
}
exports.UnaryCompareCondition = UnaryCompareCondition;
