"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualCondition = void 0;
const condition_1 = require("./condition");
/**
 * 标准操作，用于存放标准操作未转换前的标准操作
 * 用于定义一套多数据库兼容的标准
 * 如，类型转换、获取日期 等操作
 */
class VirtualCondition extends condition_1.Condition {
    constructor(name, datas) {
        super();
        this.$kind = condition_1.CONDITION_KIND.STANDARD;
        this.$name = name;
        this.$datas = datas;
    }
    static isVirtualCondition(object) {
        return condition_1.Condition.isCondition(object) && object.$kind === condition_1.CONDITION_KIND.STANDARD;
    }
    static create(name, datas) {
        return new VirtualCondition(name, datas);
    }
}
exports.VirtualCondition = VirtualCondition;
