"use strict";
/* eslint-disable @typescript-eslint/prefer-as-const */
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/ban-types */
// interface QueryParameter {
//    name: string,
//    value: any,
//    direction?: ParameterDirection
// }
Object.defineProperty(exports, "__esModule", { value: true });
exports.DbType = exports.isDbType = void 0;
function isDbType(value) {
    if (typeof value?.type !== 'string')
        return false;
    return value.type.toLowerCase() in exports.DbType;
}
exports.isDbType = isDbType;
const MAX = 0;
const float32 = Object.assign(() => float32, {
    type: 'FLOAT32',
});
const float64 = Object.assign(() => float64, {
    type: 'FLOAT64',
});
const date = Object.assign(() => date, {
    type: 'DATE',
});
const time = Object.assign(() => time, {
    type: 'TIME',
});
const datetime = Object.assign(() => datetime, {
    type: 'DATETIME',
});
const datetimeoffset = Object.assign(() => datetimeoffset, {
    type: 'DATETIMEOFFSET',
});
const boolean = Object.assign(() => boolean, {
    type: 'BOOLEAN',
});
const uuid = Object.assign(() => uuid, {
    type: 'UUID',
});
const rowflag = Object.assign(() => rowflag, {
    type: 'ROWFLAG',
});
const int8 = Object.assign(() => int8, {
    type: 'INT8',
});
const int16 = Object.assign(() => int16, {
    type: 'INT16',
});
const int32 = Object.assign(() => int32, {
    type: 'INT32',
});
const int64 = Object.assign(() => int64, {
    type: 'INT64',
});
const string = Object.assign((length) => ({
    type: 'STRING',
    size: length,
}), {
    type: 'STRING',
    size: MAX,
});
const decimal = Object.assign((precision, digit = 2) => ({
    type: 'DECIMAL',
    precision,
    scale: digit,
}), {
    type: 'DECIMAL',
    precision: 18,
    scale: 2,
});
const binary = Object.assign((length) => ({
    type: 'BINARY',
    size: length,
}), {
    type: 'BINARY',
    size: MAX,
});
const json = Object.assign(() => json, {
    type: 'JSON',
});
const list = Object.assign((innerType) => ({
    type: 'LIST',
    innerType,
}), {
    type: 'LIST',
    innerType: string,
});
/**
 * 数据库标准类型定义
 */
exports.DbType = {
    int8: {
        type: 'INT8',
    },
    int16,
    int32,
    int64,
    decimal,
    float32,
    float64,
    date,
    time,
    datetime,
    datetimeoffset,
    boolean,
    uuid,
    rowflag,
    string,
    binary,
    json,
    list,
    raw(name) {
        return new raw_1.Raw(name);
    },
    MAX,
};
// /**
//  * 所浮点类型
//  */
// export type Float = number;
const raw_1 = require("./raw");
