"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryOperation = void 0;
const expression_1 = require("./expression");
const operation_1 = require("./common/operation");
/**
 * 二元运算表达式
 */
class BinaryOperation extends operation_1.Operation {
    /**
     * 名称
     */
    constructor(operator, left, right) {
        super();
        this.$kind = operation_1.OPERATION_KIND.BINARY;
        this.$operator = operator;
        this.$left = expression_1.Expression.ensureExpression(left);
        this.$right = expression_1.Expression.ensureExpression(right);
    }
    static isBinaryOperation(object) {
        return (operation_1.Operation.isOperation(object) && object.$kind === operation_1.OPERATION_KIND.BINARY);
    }
}
exports.BinaryOperation = BinaryOperation;
