import { SQL_SYMBOLE } from '../sql';
import type { Condition } from '../condition/condition';
import type { Scalar } from '../scalar';
import { When } from './when';
import { XExpression, Expression } from './expression';
/**
 * CASE表达式
 */
export declare class Case<T extends Scalar = any, E extends Scalar = any> extends Expression<T> {
    $expr?: Expression<any>;
    $whens: When<Scalar>[];
    $default?: Expression;
    readonly $type: SQL_SYMBOLE.CASE;
    static isCase(object: any): object is Case;
    /**
     * Case语句
     * @param expr
     */
    constructor(expr?: XExpression<Scalar>);
    /**
     * ELSE语句
     * @param defaults
     */
    else<R extends Scalar>(defaults: XExpression<R>): Case<T | R, E>;
    /**
     * WHEN语句
     * @param expr
     * @param then
     */
    when<R extends Scalar>(expr: XExpression<E> | Condition, then: XExpression<R>): Case<T | R, E>;
}
