"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Case = void 0;
const sql_1 = require("../sql");
const when_1 = require("./when");
const expression_1 = require("./expression");
/**
 * CASE表达式
 */
class Case extends expression_1.Expression {
    /**
     * Case语句
     * @param expr
     */
    constructor(expr) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.CASE;
        if (expr !== undefined) {
            this.$expr = expression_1.Expression.ensureExpression(expr);
        }
        /**
         * @type {When[]}
         */
        this.$whens = [];
    }
    static isCase(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.CASE;
    }
    /**
     * ELSE语句
     * @param defaults
     */
    else(defaults) {
        this.$default = expression_1.Expression.ensureExpression(defaults);
        return this;
    }
    /**
     * WHEN语句
     * @param expr
     * @param then
     */
    when(expr, then) {
        this.$whens.push(new when_1.When(expr, then));
        return this;
    }
}
exports.Case = Case;
