import { SQL_SYMBOLE } from "../../sql";
import { Scalar } from "../../scalar/scalar";
import { Expression } from "../expression";
export declare abstract class Operation<T extends Scalar = Scalar> extends Expression<T> {
    readonly $type: SQL_SYMBOLE.OPERATION;
    abstract readonly $kind: OPERATION_KIND;
    abstract readonly $operator: OPERATION_OPERATOR;
    static isOperation(object: any): object is Operation;
}
/**
 * 算术运算符列表
 */
export declare type OPERATION_OPERATOR = BINARY_OPERATION_OPERATOR | UNARY_OPERATION_OPERATOR;
export declare enum OPERATION_KIND {
    BINARY = "BINARY",
    UNARY = "UNARY",
    CONVERT = "CONVERT"
}
export declare enum BINARY_OPERATION_OPERATOR {
    CONCAT = "CONCAT",
    ADD = "+",
    SUB = "-",
    MUL = "*",
    DIV = "/",
    MOD = "%",
    AND = "&",
    OR = "|",
    XOR = "^",
    SHR = ">>",
    SHL = "<<"
}
export declare enum UNARY_OPERATION_OPERATOR {
    NOT = "~",
    NEG = "-"
}
