"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UNARY_OPERATION_OPERATOR = exports.BINARY_OPERATION_OPERATOR = exports.OPERATION_KIND = exports.Operation = void 0;
const sql_1 = require("../../sql");
const expression_1 = require("../expression");
class Operation extends expression_1.Expression {
    constructor() {
        super(...arguments);
        this.$type = sql_1.SQL_SYMBOLE.OPERATION;
    }
    static isOperation(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.OPERATION;
    }
}
exports.Operation = Operation;
var OPERATION_KIND;
(function (OPERATION_KIND) {
    OPERATION_KIND["BINARY"] = "BINARY";
    OPERATION_KIND["UNARY"] = "UNARY";
    OPERATION_KIND["CONVERT"] = "CONVERT";
})(OPERATION_KIND = exports.OPERATION_KIND || (exports.OPERATION_KIND = {}));
var BINARY_OPERATION_OPERATOR;
(function (BINARY_OPERATION_OPERATOR) {
    BINARY_OPERATION_OPERATOR["CONCAT"] = "CONCAT";
    BINARY_OPERATION_OPERATOR["ADD"] = "+";
    BINARY_OPERATION_OPERATOR["SUB"] = "-";
    BINARY_OPERATION_OPERATOR["MUL"] = "*";
    BINARY_OPERATION_OPERATOR["DIV"] = "/";
    BINARY_OPERATION_OPERATOR["MOD"] = "%";
    BINARY_OPERATION_OPERATOR["AND"] = "&";
    BINARY_OPERATION_OPERATOR["OR"] = "|";
    BINARY_OPERATION_OPERATOR["XOR"] = "^";
    BINARY_OPERATION_OPERATOR["SHR"] = ">>";
    BINARY_OPERATION_OPERATOR["SHL"] = "<<";
})(BINARY_OPERATION_OPERATOR = exports.BINARY_OPERATION_OPERATOR || (exports.BINARY_OPERATION_OPERATOR = {}));
var UNARY_OPERATION_OPERATOR;
(function (UNARY_OPERATION_OPERATOR) {
    UNARY_OPERATION_OPERATOR["NOT"] = "~";
    UNARY_OPERATION_OPERATOR["NEG"] = "-";
})(UNARY_OPERATION_OPERATOR = exports.UNARY_OPERATION_OPERATOR || (exports.UNARY_OPERATION_OPERATOR = {}));
