import { SQL_SYMBOLE } from '../sql';
import { ObjectName } from '../object/db-object';
import type { Scalar } from '../scalar';
import { Assignable } from './common/assignable';
import type { SelectColumn } from '../statement';
import type { XRowsets } from '../rowset';
export declare class Field<T extends Scalar = Scalar, N extends string = string> extends Assignable<T> {
    static isField(object: any): object is Field;
    constructor(name: N, parent?: XRowsets);
    $table?: XRowsets;
    readonly $name: N;
    readonly $type: SQL_SYMBOLE.FIELD;
    /**
     * 将Field转换为SelectColumn，如果存在字段映射，则会自动转换为 字段名 as 属性名
     */
    as(): SelectColumn<T, N>;
    /**
     * 转换为SelectColumn并指定别名，继承于Expression
     */
    as<C extends string>(name: C): SelectColumn<T, C>;
}
export interface FieldName<N extends string> {
    table?: ObjectName;
    name: N;
}
export declare type CompatiableFieldName<N extends string = string> = FieldName<N> | N;
export declare type FieldTypeOf<T, F extends keyof T> = T[F] extends Scalar ? T[F] : never;
