"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const sql_1 = require("../sql");
const assignable_1 = require("./common/assignable");
class Field extends assignable_1.Assignable {
    constructor(name, parent) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.FIELD;
        this.$name = name;
        this.$table = parent;
    }
    static isField(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.FIELD;
    }
    as(name) {
        if (name)
            return super.as(name);
        if (this.$table?.$map) {
            if (!this.$table.$map[this.$name]) {
                throw new Error(`Rowset map property ${this.$name} not exists`);
            }
            return this.as(this.$table.$map[this.$name]);
        }
        return this.as(this.$name);
    }
}
exports.Field = Field;
