"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FunctionParameter = void 0;
const sql_1 = require("../sql");
const literal_1 = require("./literal");
const assignable_1 = require("./common/assignable");
class FunctionParameter extends assignable_1.Assignable {
    constructor(name, dataType, defaultValue) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.FUNCTION_PARAMETER;
        this.$name = name;
        this.$dbType = dataType;
        if (defaultValue) {
            this.$default = literal_1.Literal.ensureLiteral(defaultValue);
        }
    }
    static create(name, dataType, defaultValue) {
        return new FunctionParameter(name, dataType, defaultValue);
    }
}
exports.FunctionParameter = FunctionParameter;
