import { SQL_SYMBOLE } from '../sql';
import { DbType, DbTypeFromScalar } from '../db-type';
import { Scalar } from '../scalar';
import { Expression } from './expression';
/**
 * 字面量表达式
 */
export declare class Literal<T extends Scalar = Scalar> extends Expression<T> {
    constructor(value: T, dbType?: DbTypeFromScalar<T>);
    readonly $type: SQL_SYMBOLE.LITERAL;
    /**
     * 实际值
     */
    readonly $value: T;
    $dbType?: DbType;
    static isLiteral(object: any): object is Literal;
    valueOf(): T;
    /**
     * 根据值自动填充类型
     */
    fitType(): void;
    static ensureLiteral<T extends Scalar>(value: T | Literal<T>): Literal<T>;
    /**
     * 解释值的类型
     */
    static parseValueType(value: Scalar): DbType;
}
