import { SQL_SYMBOLE } from '../sql';
import { DbType } from '../db-type';
import { Scalar } from '../scalar';
import { Assignable } from './common/assignable';
/**
 * 参数方向
 */
export declare type PARAMETER_DIRECTION = 'IN' | 'OUT' | 'INOUT';
/**
 * 程序与数据库间传递值所使用的参数
 */
export declare class Parameter<T extends Scalar = any, N extends string = string> extends Assignable<T> {
    $name: N;
    $builtin: boolean;
    readonly $type: SQL_SYMBOLE.PARAMETER;
    static isParameter(object: any): object is Parameter;
    get name(): N;
    direction: PARAMETER_DIRECTION;
    type: DbType;
    value?: T;
    constructor(name: N, type?: DbType, value?: T, direction?: PARAMETER_DIRECTION);
}
