"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Parameter = void 0;
const sql_1 = require("../sql");
const literal_1 = require("./literal");
const assignable_1 = require("./common/assignable");
/**
 * 程序与数据库间传递值所使用的参数
 */
class Parameter extends assignable_1.Assignable {
    // constructor (name: N, value?: T)
    // constructor (
    //   name: N,
    //   type: DbType,
    //   value?: T,
    //   direction?: PARAMETER_DIRECTION
    // )
    constructor(name, type, value, direction = 'IN') {
        super();
        this.$builtin = false;
        this.$type = sql_1.SQL_SYMBOLE.PARAMETER;
        if (type) {
            this.type = type;
        }
        else {
            if (value === undefined) {
                throw new Error('Parameter must assign one of `value` or `type`.');
            }
            this.type = literal_1.Literal.parseValueType(value);
        }
        this.$name = name;
        this.value = value;
        this.direction = direction;
    }
    static isParameter(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.PARAMETER;
    }
    get name() {
        return this.$name;
    }
}
exports.Parameter = Parameter;
