import { SQL_SYMBOLE } from '../../sql';
import { DbType, ScalarFromDbType } from '../db-type';
import { Literal } from './literal';
import { PARAMETER_DIRECTION } from './parameter';
import { Scalar } from '../scalar';
import { Assignable } from './common/assignable';
export declare class ProcedureParameter<T extends Scalar = Scalar, N extends string = string> extends Assignable<T> {
    readonly $type: SQL_SYMBOLE.PROCEDURE_PARAMETER;
    constructor(name: N, dataType: DbType, direct?: PARAMETER_DIRECTION, defaultValue?: Literal<T> | T);
    static create<T extends DbType, N extends string>(name: N, dataType: T, direct?: PARAMETER_DIRECTION, defaultValue?: Literal<ScalarFromDbType<T>> | ScalarFromDbType<T>): ProcedureParameter<ScalarFromDbType<T>, N>;
    $dbType: DbType;
    $name: N;
    $direct: PARAMETER_DIRECTION;
    $default?: Literal;
}
