"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcedureParameter = void 0;
const sql_1 = require("../../sql");
const literal_1 = require("./literal");
const assignable_1 = require("./common/assignable");
class ProcedureParameter extends assignable_1.Assignable {
    constructor(name, dataType, direct = 'IN', defaultValue) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.PROCEDURE_PARAMETER;
        this.$name = name;
        this.$dbType = dataType;
        this.$direct = direct;
        if (defaultValue) {
            this.$default = literal_1.Literal.ensureLiteral(defaultValue);
        }
    }
    static create(name, dataType, direct = 'IN', defaultValue) {
        return new ProcedureParameter(name, dataType, direct, defaultValue);
    }
}
exports.ProcedureParameter = ProcedureParameter;
