import { SQL_SYMBOLE } from '../sql';
import { XExpression, Expression } from './expression';
import { Func, BuiltIn, XObjectName, Star } from '../object';
import { BaseScalar, Scalar } from '../scalar';
import type { Sort } from '../statement';
/**
 * 函数调用表达式
 */
export declare class ScalarFuncInvoke<TReturn extends Scalar = any> extends Expression<TReturn> {
    $func: Func<string>;
    $args: (Expression | BuiltIn | Star)[];
    readonly $type: SQL_SYMBOLE.SCALAR_FUNCTION_INVOKE;
    $orders?: Sort[];
    $partitions?: Expression[];
    static isScalarFuncInvoke(object: any): object is ScalarFuncInvoke;
    constructor(func: XObjectName | Func<string>, args: (XExpression<Scalar> | BuiltIn<string> | Star)[]);
    over(action?: (builder: Pick<ScalarFuncInvoke, 'orderBy' | 'partitionBy'>) => void): this;
    /**
     * 开窗函数调用
     */
    orderBy(...sorts: Sort[]): this;
    orderBy(sorts: Sort[]): this;
    /**
     * 分组
     */
    partitionBy(exprs: XExpression<BaseScalar>[]): this;
    partitionBy(...exprs: XExpression<BaseScalar>[]): this;
}
