"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScalarFuncInvoke = void 0;
const sql_1 = require("../sql");
const expression_1 = require("./expression");
const object_1 = require("../object");
const literal_1 = require("./literal");
/**
 * 函数调用表达式
 */
class ScalarFuncInvoke extends expression_1.Expression {
    // TODO: 是否需参数的类型判断，拦截ValuedSelect之类的表达式进入？
    constructor(func, args) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.SCALAR_FUNCTION_INVOKE;
        this.$func = object_1.Func.ensure(func);
        this.$args = args.map(expr => {
            if (!(expr instanceof sql_1.Sql))
                return new literal_1.Literal(expr);
            return expr;
        });
    }
    static isScalarFuncInvoke(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.SCALAR_FUNCTION_INVOKE;
    }
    over(action) {
        action?.(this);
        return this;
    }
    orderBy(...sorts) {
        this.$orders = Array.isArray(sorts[0]) ? sorts[0] : sorts;
        return this;
    }
    partitionBy(...exprs) {
        const items = (Array.isArray(exprs[0]) ? exprs[0] : exprs);
        this.$partitions = items.map(item => expression_1.Expression.ensureExpression(item));
        return this;
    }
}
exports.ScalarFuncInvoke = ScalarFuncInvoke;
