"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnaryOperation = void 0;
const operation_1 = require("./common/operation");
const expression_1 = require("./expression");
/**
 * 一元运算符
 */
class UnaryOperation extends operation_1.Operation {
    /**
     * 一元运算
     * @param value
     */
    constructor(operator, value) {
        super();
        this.$kind = operation_1.OPERATION_KIND.UNARY;
        this.$operator = operator;
        this.$value = expression_1.Expression.ensureExpression(value);
    }
    static isUnaryOperation(object) {
        return (operation_1.Operation.isOperation(object) && object.$kind === operation_1.OPERATION_KIND.UNARY);
    }
}
exports.UnaryOperation = UnaryOperation;
