"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualExpression = void 0;
const sql_1 = require("../sql");
const expression_1 = require("./expression");
/**
 * 标准操作，用于存放标准操作未转换前的标准操作
 * 用于定义一套多数据库兼容的标准
 * 如，类型转换、获取日期 等操作
 */
class VirtualExpression extends expression_1.Expression {
    constructor(name, datas) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.VIRTUAL_EXPRESSION;
        this.$name = name;
        this.$datas = datas;
    }
    static isVirtualExpression(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.VIRTUAL_EXPRESSION;
    }
    static create(name, datas) {
        return new VirtualExpression(name, datas);
    }
}
exports.VirtualExpression = VirtualExpression;
