"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.When = void 0;
const sql_1 = require("../sql");
const expression_1 = require("./expression");
/**
 * When语句
 */
class When extends sql_1.Sql {
    constructor(expr, then) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.WHEN;
        if (expression_1.Expression.isExpression(expr) || condition_1.Condition.isCondition(expr)) {
            this.$expr = expr;
        }
        else if (!expression_1.Expression.isExpression(expr)) {
            this.$expr = new literal_1.Literal(expr);
        }
        else {
            this.$expr = expr;
        }
        this.$value = expression_1.Expression.ensureExpression(then);
    }
}
exports.When = When;
const condition_1 = require("../condition");
const literal_1 = require("./literal");
