import { SQL_SYMBOLE } from '../sql';
import { Scalar } from '../scalar';
import { DefaultRowObject, RowObject } from '../types';
import { XObjectName, DBObject } from './db-object';
import { BuiltIn } from './built-in';
import { Star } from './star';
export declare class Func<N extends string = string> extends DBObject<N> {
    readonly $type: SQL_SYMBOLE.FUNCTION;
    /**
     * 如果未传函数类型，则使用标题函数作为默认类型
     */
    constructor(name: XObjectName<N>, buildIn?: boolean);
    invokeAsTable<T extends RowObject = DefaultRowObject>(...args: (XExpression<Scalar> | BuiltIn<string> | Star)[]): XRowset<T>;
    invokeAsScalar<T extends Scalar>(...args: (XExpression<Scalar> | BuiltIn<string> | Star)[]): ScalarFuncInvoke<T>;
    static isFunc(object: any): object is Func;
    static ensure(object: XObjectName | Func): Func;
}
import { ScalarFuncInvoke, XExpression } from '../expression';
import { XRowset } from '../rowset';
