"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Func = void 0;
const sql_1 = require("../sql");
const db_object_1 = require("./db-object");
class Func extends db_object_1.DBObject {
    /**
     * 如果未传函数类型，则使用标题函数作为默认类型
     */
    constructor(name, buildIn = false
    // type?: K
    ) {
        super(name, buildIn);
        this.$type = sql_1.SQL_SYMBOLE.FUNCTION;
        // this.$ftype = type || (FUNCTION_TYPE.SCALAR as K)
    }
    invokeAsTable(...args) {
        return new rowset_1.TableFuncInvoke(this, args);
    }
    invokeAsScalar(...args) {
        return new expression_1.ScalarFuncInvoke(this, args);
    }
    static isFunc(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.FUNCTION;
    }
    static ensure(object) {
        if (Func.isFunc(object))
            return object;
        return new Func(object);
    }
}
exports.Func = Func;
const expression_1 = require("../expression");
const rowset_1 = require("../rowset");
