import { SQL_SYMBOLE } from '../sql';
import type { Scalar } from '../scalar';
import type { InputObject, RowObject } from '../types';
import { XObjectName, DBObject } from './db-object';
/**
 * @param N 存储过程名称
 * @param R 返回值
 * @param O 输出行集
 */
export declare class Procedure<R extends Scalar = number, O extends RowObject[] = [], N extends string = string> extends DBObject<N> {
    readonly $type: SQL_SYMBOLE.PROCEDURE;
    execute(...params: [XExpression]): Execute<R>;
    execute(...params: Parameter<Scalar, string>[]): Execute<R>;
    execute(params: InputObject): Execute<R>;
    static isProcedure(object: any): object is Procedure<any, any, any>;
    static ensure(proc: XObjectName | Procedure<any, any, any>): Procedure<any, any, any>;
}
import { XExpression, Parameter } from '../expression';
import { Execute } from '../statement';
