"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Procedure = void 0;
const sql_1 = require("../sql");
const db_object_1 = require("./db-object");
/**
 * @param N 存储过程名称
 * @param R 返回值
 * @param O 输出行集
 */
class Procedure extends db_object_1.DBObject {
    constructor() {
        super(...arguments);
        this.$type = sql_1.SQL_SYMBOLE.PROCEDURE;
    }
    execute(...params) {
        return new statement_1.Execute(this.$name, params);
    }
    static isProcedure(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.PROCEDURE;
    }
    static ensure(proc) {
        if (Procedure.isProcedure(proc)) {
            return proc;
        }
        return new Procedure(proc);
    }
}
exports.Procedure = Procedure;
const statement_1 = require("../statement");
