import { SQL_SYMBOLE } from '../sql';
import { Field } from '../expression';
import { ColumnsOf, DataRowValueType, DefaultRowObject, RowObject } from '../types';
import { Rowset } from './rowset';
/**
 * 具名SELECT语句，可用于子查询，With语句等
 */
export declare class NamedSelect<T extends RowObject = DefaultRowObject> extends Rowset<T> {
    readonly $type: SQL_SYMBOLE.NAMED_SELECT;
    $select: Select<T>;
    $name: string;
    $alias: never;
    private constructor();
    as(): never;
    static isNamedSelect(object: any): object is NamedSelect;
    static create<T extends RowObject = DefaultRowObject, A extends string = string>(statement: Select<T>, name: A): NamedSelect<T>;
}
export declare type XNamedSelect<T extends RowObject = RowObject, N extends string = string> = NamedSelect<T> & {
    readonly [P in ColumnsOf<T>]: Field<DataRowValueType<T[P]>, P>;
};
import { Select } from '../statement/query/select';
