"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NamedSelect = void 0;
const sql_1 = require("../sql");
const rowset_1 = require("./rowset");
/**
 * 具名SELECT语句，可用于子查询，With语句等
 */
class NamedSelect extends rowset_1.Rowset {
    constructor(statement, name) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.NAMED_SELECT;
        this.$name = name;
        this.$select = statement;
        this.$proxy();
    }
    as() {
        throw new Error(`NamedSelect dos not allow with alias.`);
    }
    static isNamedSelect(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.NAMED_SELECT;
    }
    static create(statement, name) {
        return new NamedSelect(statement, name);
    }
}
exports.NamedSelect = NamedSelect;
