import { SQL_SYMBOLE } from '../sql';
import { XExpression, Expression, Field } from '../expression';
import { BuiltIn, XObjectName, Func, Star } from '../object';
import { Rowset } from './rowset';
import { Scalar } from '../scalar';
import { ColumnsOf, DataRowValueType, DefaultRowObject, RowObject } from '../types';
export declare class TableFuncInvoke<TReturn extends RowObject = DefaultRowObject> extends Rowset<TReturn> {
    readonly $func: Func<string>;
    readonly $args: (Expression<Scalar> | Star | BuiltIn)[];
    readonly $type: SQL_SYMBOLE.TABLE_FUNCTION_INVOKE;
    $name?: string;
    $alias?: never;
    static isTableFuncInvoke(object: any): object is TableFuncInvoke;
    constructor(func: XObjectName | Func<string>, args: (XExpression<Scalar> | BuiltIn<string> | Star)[]);
    static create<T extends RowObject = DefaultRowObject>(func: XObjectName | Func<string>, args: (XExpression<Scalar> | BuiltIn<string> | Star)[]): XTableFuncInvoke<T>;
}
/**
 * 代理后的表
 */
export declare type XTableFuncInvoke<T extends RowObject = RowObject> = TableFuncInvoke<T> & {
    readonly [P in ColumnsOf<T>]: Field<DataRowValueType<T[P]>, string>;
};
