"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableFuncInvoke = void 0;
const sql_1 = require("../sql");
const expression_1 = require("../expression");
const object_1 = require("../object");
const rowset_1 = require("./rowset");
class TableFuncInvoke extends rowset_1.Rowset {
    constructor(func, args) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.TABLE_FUNCTION_INVOKE;
        this.$func = object_1.Func.ensure(func);
        this.$args = args.map(expr => expr instanceof sql_1.Sql ? expr : new expression_1.Literal(expr));
        this.$proxy();
    }
    static isTableFuncInvoke(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.TABLE_FUNCTION_INVOKE;
    }
    static create(func, args) {
        return new TableFuncInvoke(func, args);
    }
}
exports.TableFuncInvoke = TableFuncInvoke;
