"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTableVariant = exports.TableVariant = void 0;
const sql_1 = require("../sql");
const rowset_1 = require("./rowset");
class TableVariant extends rowset_1.Rowset {
    constructor(name) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.TABLE_VARIANT;
        this.$name = name;
        this.$proxy();
    }
    static isTableVariant(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.TABLE_VARIANT;
    }
    as(members) {
        if (typeof members === 'string') {
            return super.as(members);
        }
        this.$body = members;
        return this;
    }
}
exports.TableVariant = TableVariant;
function createTableVariant(name, members) {
    if (typeof members === 'function') {
        members = members(createTableVariant);
    }
    return new TableVariant(name).as(members);
}
exports.createTableVariant = createTableVariant;
createTableVariant.primaryKey = (name) => {
    return new statement_1.PrimaryKey(name);
};
createTableVariant.column = (name, type) => {
    return new statement_1.ColumnDeclareForAdd(name, type);
};
createTableVariant.check = (nameOrSql, _sql) => {
    let name;
    let sql;
    if (typeof nameOrSql === 'string') {
        name = nameOrSql;
        sql = _sql;
    }
    else {
        sql = nameOrSql;
    }
    return new statement_1.CheckConstraint(sql, name);
};
createTableVariant.uniqueKey = (name) => {
    return new statement_1.UniqueKey(name);
};
const statement_1 = require("../statement");
