import { SQL_SYMBOLE } from '../sql';
import { Field } from '../expression';
import { XObjectName, DBObject } from '../object';
import { ColumnsOf, DataRowValueType, DefaultRowObject, RowObject } from '../types';
import { Rowset } from './rowset';
import type { XTableVariant } from './table-variant';
/**
 * 表对象，表和视图均使用该对象
 */
export declare class Table<T extends RowObject = DefaultRowObject> extends Rowset<T> implements DBObject {
    constructor(name: XObjectName, builtIn?: boolean);
    static create<T extends RowObject = DefaultRowObject, N extends string = string>(name: XObjectName<N>, builtIn?: boolean): XTable<T>;
    $name: XObjectName;
    readonly $builtin: boolean;
    readonly $type: SQL_SYMBOLE.TABLE;
    as: <N extends string>(alias: N) => XTable<T>;
    static isTable(object: any): object is Table | XTable;
}
export declare type XTables<T extends RowObject = {}> = XObjectName | XTable<T> | XTableVariant<T>;
/**
 * 代理后的表
 */
export declare type XTable<T extends RowObject = RowObject> = Table<T> & {
    readonly [P in ColumnsOf<T>]: Field<DataRowValueType<T[P]>, P>;
};
export declare const tableBuilder: TableBuilder;
export interface TableBuilder {
    <T extends RowObject>(name: XObjectName, builtIn?: boolean): XTable<T>;
}
