"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tableBuilder = exports.Table = void 0;
const sql_1 = require("../sql");
const rowset_1 = require("./rowset");
/**
 * 表对象，表和视图均使用该对象
 */
class Table extends rowset_1.Rowset {
    constructor(name, builtIn = false) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.TABLE;
        this.$name = name;
        this.$builtin = builtIn;
        this.$proxy();
    }
    static create(name, builtIn = false) {
        return new Table(name, builtIn);
    }
    static isTable(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.TABLE;
    }
}
exports.Table = Table;
const tableBuilder = function (name, builtIn = false) {
    return new Table(name, builtIn);
};
exports.tableBuilder = tableBuilder;
