import { SQL_SYMBOLE } from '../sql';
import { Rowset } from './rowset';
import { Field } from '../expression/field';
import type { Select } from '../statement';
import { ColumnsOf, DataRowValueType, DefaultRowObject, RowObject } from '../types';
export declare class WithSelect<T extends RowObject = any> extends Rowset<T> {
    private constructor();
    readonly $type: SQL_SYMBOLE.WITH_SELECT;
    $select: Select<T>;
    $alias?: string;
    /**
     * WITH 声明名称
     */
    $name: string;
    static isWithSelect(object: any): object is WithSelect;
    static create<T extends RowObject = DefaultRowObject, N extends string = string>(name: string, select: Select<T>): XWithSelect<T>;
}
export declare type XWithSelect<T extends RowObject = RowObject> = WithSelect<T> & {
    readonly [P in ColumnsOf<T>]: Field<DataRowValueType<T[P]>, P>;
};
