"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SQL_SYMBOLE = exports.Sql = void 0;
const util_1 = require("./util");
/**
 * 所有AST类的基类
 */
class Sql {
    /**
     * 克隆自身
     */
    clone() {
        return (0, util_1.clone)(this);
    }
}
exports.Sql = Sql;
var SQL_SYMBOLE;
(function (SQL_SYMBOLE) {
    SQL_SYMBOLE["DECLARE"] = "DECLARE";
    SQL_SYMBOLE["EXPRESSION"] = "EXPRESSION";
    SQL_SYMBOLE["CREATE_TABLE_COLUMN"] = "CREATE_TABLE_COLUMN";
    SQL_SYMBOLE["STAR"] = "STAR";
    SQL_SYMBOLE["RAW"] = "RAW";
    SQL_SYMBOLE["STATEMENT"] = "STATEMENT";
    // ANY = '*',
    SQL_SYMBOLE["INVOKE_ARGUMENT_LIST"] = "INVOKE_ARGUMENT_LIST";
    SQL_SYMBOLE["EXECUTE_ARGUMENT_LIST"] = "EXECUTE_ARGUMENT_LIST";
    SQL_SYMBOLE["VARAINT_DECLARE"] = "VARAINT_DECLARE";
    SQL_SYMBOLE["TABLE_VARIANT_DECLARE"] = "TABLE_VARIANT_DECLARE";
    SQL_SYMBOLE["IDENTIFIER"] = "IDENTIFIER";
    SQL_SYMBOLE["IDENTITY_VALUE"] = "IDENTITY_VALUE";
    SQL_SYMBOLE["VIRTUAL_EXPRESSION"] = "STANDARD_EXPRESSION";
    SQL_SYMBOLE["SCALAR_FUNCTION_INVOKE"] = "SCALAR_FUNCTION_INVOKE";
    SQL_SYMBOLE["TABLE_FUNCTION_INVOKE"] = "TABLE_FUNCTION_INVOKE";
    SQL_SYMBOLE["LITERAL"] = "LITERAL";
    SQL_SYMBOLE["SORT"] = "SORT";
    SQL_SYMBOLE["JOIN"] = "JOIN";
    SQL_SYMBOLE["UNION"] = "UNION";
    SQL_SYMBOLE["WHEN"] = "WHEN";
    SQL_SYMBOLE["CASE"] = "CASE";
    SQL_SYMBOLE["DOCUMENT"] = "DOCUMENT";
    SQL_SYMBOLE["WITH"] = "WITH";
    SQL_SYMBOLE["GROUP_EXPRESSION"] = "GROUP_EXPRESSION";
    SQL_SYMBOLE["NAMED_SELECT"] = "NAMED_SELECT";
    SQL_SYMBOLE["WITH_SELECT"] = "WITH_SELECT";
    SQL_SYMBOLE["OPERATION"] = "OPERATION";
    SQL_SYMBOLE["VALUED_SELECT"] = "VALUED_SELECT";
    SQL_SYMBOLE["PRIMARY_KEY"] = "CREATE_TABLE_PRIMARY_KEY";
    SQL_SYMBOLE["FOREIGN_KEY"] = "FOREIGN_KEY";
    SQL_SYMBOLE["ALTER_TABLE_DROP_MEMBER"] = "ALTER_TABLE_DROP_COLUMN";
    SQL_SYMBOLE["ALTER_TABLE_DROP_CONSTRAINT"] = "ALTER_TABLE_DROP_CONSTRAINT";
    SQL_SYMBOLE["CHECK_CONSTRAINT"] = "CHECK_CONSTRAINT";
    SQL_SYMBOLE["UNIQUE_KEY"] = "UNIQUE_KEY";
    SQL_SYMBOLE["PROCEDURE_PARAMETER"] = "PROCEDURE_PARAMETER";
    SQL_SYMBOLE["FUNCTION_PARAMETER"] = "FUNCTION_PARAMETER";
    SQL_SYMBOLE["ALTER_TABLE_COLUMN"] = "ALTER_TABLE_COLUMN";
    SQL_SYMBOLE["CONDITION"] = "CONDITION";
    SQL_SYMBOLE["PARAMETER"] = "PARAMETER";
    /**
     * 表
     */
    SQL_SYMBOLE["TABLE"] = "TABLE";
    /**
     * 字段
     */
    SQL_SYMBOLE["FIELD"] = "FIELD";
    /**
     * 函数
     */
    SQL_SYMBOLE["FUNCTION"] = "FUNCITON";
    /**
     * 序列
     */
    SQL_SYMBOLE["SEQUENCE"] = "SEQUENCE";
    // /**
    //  * 标量函数
    //  */
    // SCALAR_FUNCTION ='SCALAR_FUNCTION',
    // /**
    //  * 表值函数
    //  */
    // TABLE_FUNCTION = 'TABLE_FUNCTION',
    /**
     * 存储过程
     */
    SQL_SYMBOLE["PROCEDURE"] = "PROCEDURE";
    /**
     * 内建标识
     */
    SQL_SYMBOLE["BUILT_IN"] = "BUILT_IN";
    /**
     * 别名
     */
    SQL_SYMBOLE["ALIAS"] = "ALIAS";
    /**
     * 列
     */
    SQL_SYMBOLE["SELECT_COLUMN"] = "SELECT_COLUMN";
    /**
     * 变量
     */
    SQL_SYMBOLE["VARIANT"] = "VARIANT";
    /**
     * 表变量
     */
    SQL_SYMBOLE["TABLE_VARIANT"] = "TABLE_VARIANT";
    /**
     * 对象
     */
    SQL_SYMBOLE["OBJECT"] = "OBJECT";
    SQL_SYMBOLE["ROWSET"] = "ROWSET";
    SQL_SYMBOLE["ROW_NUMBER"] = "ROW_NUMBER";
})(SQL_SYMBOLE = exports.SQL_SYMBOLE || (exports.SQL_SYMBOLE = {}));
