"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Assignment = void 0;
const expression_1 = require("../../expression");
const statement_1 = require("../statement");
/**
 * 赋值语句
 */
class Assignment extends statement_1.Statement {
    constructor(left, right) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.ASSIGNMENT;
        this.$tag = statement_1.STATEMENT_TAG.CONTROL;
        this.left = left;
        this.right = expression_1.Expression.ensureExpression(right);
    }
    static isAssignment(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.ASSIGNMENT);
    }
}
exports.Assignment = Assignment;
