"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Block = void 0;
const statement_1 = require("../statement");
/**
 * 语句块
 */
class Block extends statement_1.Statement {
    constructor(statements, declares) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.BLOCK;
        this.$tag = statement_1.STATEMENT_TAG.CONTROL;
        this.$body = statements;
        this.$declares = declares;
    }
    append(...statements) {
        if (!this.$body) {
            this.$body = [];
        }
        this.$body.push(...statements);
    }
    static isBlock(object) {
        return (statement_1.Statement.isStatement(object) && object.$kind === statement_1.STATEMENT_KIND.BLOCK);
    }
}
exports.Block = Block;
