import { Condition } from '../../condition';
import { Statement, STATEMENT_KIND, STATEMENT_TAG } from '../statement';
export declare class If extends Statement {
    $kind: STATEMENT_KIND.IF;
    $then?: Statement;
    $elseif?: [Condition, Statement | undefined][];
    $else?: Statement;
    $condition: Condition;
    $tag: STATEMENT_TAG.CONTROL;
    constructor(condition: Condition);
    then(statement: Statement): this;
    then(statements: Statement[]): this;
    then(...statements: Statement[]): this;
    elseif(condition: Condition): {
        then(...args: Statement[] | [Statement[] | Statement]): If;
    };
    else(statement: Statement): this;
    else(statements: Statement[]): this;
    else(...statements: Statement[]): this;
    static isIf(object: any): object is If;
}
