"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.While = void 0;
const statement_1 = require("../statement");
const block_1 = require("./block");
class While extends statement_1.Statement {
    constructor(condition) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.WHILE;
        this.$tag = statement_1.STATEMENT_TAG.CONTROL;
        this.$condition = condition;
    }
    do(...statements) {
        if (statements.length === 1 && Array.isArray(statements[0])) {
            statements = statements[0];
        }
        if (statements.length > 0) {
            this.$statement = new block_1.Block(statements);
        }
        else {
            this.$statement = statements[0];
        }
        return this;
    }
    static isWhile(object) {
        return (statement_1.Statement.isStatement(object) && object.$kind === statement_1.STATEMENT_KIND.WHILE);
    }
}
exports.While = While;
