import { XCondition, Condition } from '../../../condition';
import { RowObject } from '../../../types';
import { XRowsets, XRowset } from '../../../rowset';
import { XObjectName } from '../../../object';
import type { With } from '../with';
import { Join } from './join';
import { Statement } from '../../statement';
export declare abstract class Fromable<T extends RowObject = any> extends Statement {
    $froms?: XRowset[];
    $joins?: Join[];
    $where?: Condition;
    $with?: With;
    /**
     * 从表中查询，可以查询多表
     * @param tables
     */
    from(...tables: (XRowsets | XObjectName)[]): this;
    /**
     * 表联接
     * @param table
     * @param on
     * @param left
     * @memberof Select
     */
    join<T extends RowObject = any>(table: XRowsets<T> | XObjectName, on: Condition, left?: boolean): this;
    /**
     * 左联接
     * @param table
     * @param on
     */
    leftJoin<T extends RowObject = any>(table: XRowsets<T> | XObjectName, on: Condition): this;
    protected ensureCondition(condition: XCondition<T>): Condition;
    /**
     * where查询条件
     * @param conditions
     */
    where(conditions: XCondition<T>): this;
    where(...conditions: XCondition<T>[]): this;
    /**
     * 追加查询条件
     * @param condition
     * @returns
     */
    andWhere(condition: XCondition<T>): this;
}
