"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Join = void 0;
const sql_1 = require("../../../sql");
const rowset_1 = require("../../../rowset");
/**
 * 联接查询
 */
class Join extends sql_1.Sql {
    /**
     * 创建一个表关联
     * @param table
     * @param on 关联条件
     * @param left 是否左联接
     */
    constructor(table, on, left = false) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.JOIN;
        this.$table = rowset_1.Rowset.isRowset(table) ? table : rowset_1.Table.create(table);
        this.$on = on;
        this.$left = left;
    }
}
exports.Join = Join;
