"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Delete = void 0;
const condition_1 = require("../../condition");
const rowset_1 = require("../../rowset");
const statement_1 = require("../statement");
const fromable_1 = require("./common/fromable");
class Delete extends fromable_1.Fromable {
    constructor(table) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DELETE;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$table =
            rowset_1.Table.isTable(table) || rowset_1.TableVariant.isTableVariant(table)
                ? table
                : rowset_1.Table.create(table);
    }
    static isDelete(object) {
        return (statement_1.Statement.isStatement(object) && object.$kind === statement_1.STATEMENT_KIND.DELETE);
    }
    ensureCondition(condition) {
        if (!condition_1.Condition.isCondition(condition)) {
            return condition_1.ConditionBuilder.parse(condition, this.$table);
        }
        return condition;
    }
}
exports.Delete = Delete;
