import { Scalar } from '../../scalar';
import { XExpression, Expression } from '../../expression';
import { XObjectName, Procedure, BuiltIn } from '../../object';
import { RowObject } from '../../types';
import { Statement, STATEMENT_KIND, STATEMENT_TAG } from '../statement';
/**
 * 存储过程执行
 */
export declare class Execute<R extends Scalar = any, O extends RowObject[] = []> extends Statement {
    static isExecute(object: any): object is Execute;
    readonly $proc: Procedure<R, O, string>;
    readonly $args: (BuiltIn | Expression)[];
    readonly $kind: STATEMENT_KIND.EXECUTE;
    readonly $tag: STATEMENT_TAG.EXECUTABLE;
    constructor(proc: XObjectName | Procedure<R, O, string>, params?: XExpression<Scalar>[]);
}
