"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Execute = void 0;
const expression_1 = require("../../expression");
const object_1 = require("../../object");
const statement_1 = require("../statement");
/**
 * 存储过程执行
 */
class Execute extends statement_1.Statement {
    constructor(proc, params) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.EXECUTE;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$proc = object_1.Procedure.ensure(proc);
        this.$args = (params || []).map(expr => expression_1.Expression.ensureExpression(expr));
    }
    static isExecute(object) {
        return (statement_1.Statement.isStatement(object) && object.$kind === statement_1.STATEMENT_KIND.EXECUTE);
    }
}
exports.Execute = Execute;
