import { Scalar } from '../../scalar';
import { Sql, SQL_SYMBOLE } from '../../sql';
import { ColumnsOf, RowObject } from '../../types';
import { XExpression, Expression } from '../../expression';
import { SelectColumn } from './select-column';
export declare class Sort extends Sql {
    readonly $type: SQL_SYMBOLE.SORT;
    $expr: Expression | SelectColumn;
    $direction: SORT_DIRECTION;
    constructor(expr: XExpression<Scalar>, direction?: SORT_DIRECTION);
    static isSort(object: any): object is Sort;
}
export declare type SORT_DIRECTION = 'ASC' | 'DESC';
/**
 * 排序对象
 */
export declare type SortObject<T extends RowObject = any> = {
    [K in ColumnsOf<T>]?: SORT_DIRECTION;
};
