import { XCondition, Condition } from '../../condition';
import { XTables, Table } from '../../rowset';
import { Scalar } from '../../scalar';
import { InputObject, RowObject } from '../../types';
import { STATEMENT_KIND, STATEMENT_TAG } from '../statement';
import { Fromable } from './common/fromable';
import { Assignment } from '../control';
/**
 * Update 语句
 */
export declare class Update<T extends RowObject = any> extends Fromable<T> {
    $table: Table<T>;
    $sets?: Assignment<Scalar>[];
    readonly $kind: STATEMENT_KIND.UPDATE;
    $tag: STATEMENT_TAG.EXECUTABLE;
    constructor(table: XTables<T>);
    /**
     * @param sets
     */
    set(sets: InputObject<T> | Assignment<Scalar>[]): this;
    set(...sets: Assignment<Scalar>[]): this;
    protected ensureCondition(condition: XCondition<T>): Condition;
    static isUpdate(object: any): object is Update;
}
