import { SQL_SYMBOLE } from '../../sql';
import { Condition } from '../../condition';
import { DbType, ScalarFromDbType } from '../../db-type';
import { XExpression, Expression } from '../../expression';
import { ColumnDeclare } from './column-declare';
export declare class ColumnDeclareForAdd<N extends string = string, T extends DbType = DbType> extends ColumnDeclare<N, T> {
    static isColumnDeclareForAdd(object: any): object is ColumnDeclareForAdd;
    readonly $type: SQL_SYMBOLE.CREATE_TABLE_COLUMN;
    $default?: Expression<ScalarFromDbType<T>>;
    $primaryKey?: {
        nonclustered: boolean;
    };
    $calculate?: Expression<ScalarFromDbType<T>>;
    $identity?: {
        startValue: number;
        increment: number;
    };
    $check?: Condition;
    as(value: Expression<ScalarFromDbType<T>>): this;
    identity(startValue?: number, increment?: number): this;
    check(sql: Condition): this;
    primaryKey(nonclustered?: boolean): this;
    default(value: XExpression): this;
}
