"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnDeclareForAdd = void 0;
const sql_1 = require("../../sql");
const expression_1 = require("../../expression");
const column_declare_1 = require("./column-declare");
class ColumnDeclareForAdd extends column_declare_1.ColumnDeclare {
    constructor() {
        super(...arguments);
        this.$type = sql_1.SQL_SYMBOLE.CREATE_TABLE_COLUMN;
    }
    static isColumnDeclareForAdd(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.CREATE_TABLE_COLUMN;
    }
    as(value) {
        this.$calculate = value;
        return this;
    }
    identity(startValue = 0, increment = 1) {
        this.$identity = {
            startValue,
            increment,
        };
        return this;
    }
    check(sql) {
        this.$check = sql;
        return this;
    }
    primaryKey(nonclustered = false) {
        this.$primaryKey = {
            nonclustered,
        };
        return this;
    }
    default(value) {
        this.$default = expression_1.Expression.ensureExpression(value);
        return this;
    }
}
exports.ColumnDeclareForAdd = ColumnDeclareForAdd;
