"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateDatabaseBuilder = exports.CreateDatabase = void 0;
const statement_1 = require("../statement");
class CreateDatabase extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.CREATE_DATABASE;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isCreateDatabase(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.CREATE_DATABASE);
    }
    collate(collate) {
        this.$collate = collate;
    }
}
exports.CreateDatabase = CreateDatabase;
const CreateDatabaseBuilder = (name) => {
    return new CreateDatabase(name);
};
exports.CreateDatabaseBuilder = CreateDatabaseBuilder;
exports.CreateDatabaseBuilder.ifNotExists = function (name) {
    const statement = (0, exports.CreateDatabaseBuilder)(name);
    statement.$behavior = 'CREATE_IF_NOT_EXISTS';
    return statement;
};
