"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateSchemaBuilder = exports.CreateSchema = void 0;
const statement_1 = require("../statement");
class CreateSchema extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.CREATE_SCHEMA;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isCreateSchema(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.CREATE_DATABASE);
    }
}
exports.CreateSchema = CreateSchema;
const CreateSchemaBuilder = (name) => {
    return new CreateSchema(name);
};
exports.CreateSchemaBuilder = CreateSchemaBuilder;
exports.CreateSchemaBuilder.ifNotExists = function (name) {
    const statement = (0, exports.CreateSchemaBuilder)(name);
    statement.$behavior = 'CREATE_IF_NOT_EXISTS';
    return statement;
};
