import { DbType, ScalarFromDbType } from '../../db-type';
import { Literal } from '../../expression';
import { XObjectName } from '../../object';
import { Scalar } from '../../scalar';
import { Statement, STATEMENT_KIND, STATEMENT_TAG } from '../statement';
import { CreateBehavior } from './types';
export declare class CreateSequence<T extends Scalar = any, N extends string = string> extends Statement {
    static isCreateSequence(object: any): object is CreateSequence;
    $kind: STATEMENT_KIND.CREATE_SEQUENCE;
    $name: XObjectName<N>;
    $startValue: Literal<number>;
    $increment: Literal<number>;
    $dbType?: DbType;
    $behavior?: CreateBehavior;
    $tag: STATEMENT_TAG.EXECUTABLE;
    constructor(name: XObjectName<N>);
    as<T extends DbType>(type: T): CreateSequence<ScalarFromDbType<T>, N>;
    startWith(value: number | Literal<number>): this;
    incrementBy(value: number | Literal<number>): this;
}
export declare function CreateSequenceBuilder<N extends string>(name: XObjectName<N>): CreateSequence<N>;
export declare namespace CreateSequenceBuilder {
    var ifNotExists: <N extends string>(name: XObjectName<N>) => CreateSequence<N, string>;
}
export declare type CreateSequenceBuilder = typeof CreateSequenceBuilder;
