"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateSequenceBuilder = exports.CreateSequence = void 0;
const expression_1 = require("../../expression");
const statement_1 = require("../statement");
class CreateSequence extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.CREATE_SEQUENCE;
        this.$startValue = new expression_1.Literal(0);
        this.$increment = new expression_1.Literal(1);
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isCreateSequence(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.CREATE_SEQUENCE);
    }
    as(type) {
        this.$dbType = type;
        return this;
    }
    startWith(value) {
        this.$startValue = expression_1.Literal.ensureLiteral(value);
        return this;
    }
    incrementBy(value) {
        this.$increment = expression_1.Literal.ensureLiteral(value);
        return this;
    }
}
exports.CreateSequence = CreateSequence;
function CreateSequenceBuilder(name) {
    return new CreateSequence(name);
}
exports.CreateSequenceBuilder = CreateSequenceBuilder;
CreateSequenceBuilder.ifNotExists = function ifNotExists(name) {
    const statement = CreateSequenceBuilder(name);
    statement.$behavior = 'CREATE_IF_NOT_EXISTS';
    return statement;
};
