"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateTableMemberBuilder = void 0;
const check_constraint_1 = require("./check-constraint");
const column_declare_for_add_1 = require("./column-declare-for-add");
const foreign_key_1 = require("./foreign-key");
const primary_key_1 = require("./primary-key");
const unique_key_1 = require("./unique-key");
exports.CreateTableMemberBuilder = {
    primaryKey(name) {
        return new primary_key_1.PrimaryKey(name);
    },
    column(name, type) {
        return new column_declare_for_add_1.ColumnDeclareForAdd(name, type);
    },
    check(nameOrSql, _sql) {
        let name;
        let sql;
        if (typeof nameOrSql === 'string') {
            name = nameOrSql;
            sql = _sql;
        }
        else {
            sql = nameOrSql;
        }
        return new check_constraint_1.CheckConstraint(sql, name);
    },
    uniqueKey(name) {
        return new unique_key_1.UniqueKey(name);
    },
    foreignKey(name) {
        return new foreign_key_1.ForeignKey(name);
    },
};
