import { XObjectName } from '../../object';
import { RowObject } from '../../types';
import { Select } from '../query';
import { Statement, STATEMENT_KIND, STATEMENT_TAG } from '../statement';
import { CreateBehavior } from './types';
export declare class CreateView<T extends RowObject = any, N extends string = string> extends Statement {
    static isCreateView(object: any): object is CreateView;
    $kind: STATEMENT_KIND.CREATE_VIEW;
    $name: XObjectName<N>;
    $body?: Select<T>;
    $behavior?: CreateBehavior;
    $tag: STATEMENT_TAG.EXECUTABLE;
    constructor(name: XObjectName<N>);
    as(select: Select<T>): this;
}
export declare function CreateViewBuilder<N extends string>(name: XObjectName<N>): CreateView;
export declare namespace CreateViewBuilder {
    var ifNotExists: (name: XObjectName<string>) => CreateView<any, string>;
}
export declare type CreateViewBuilder = typeof CreateViewBuilder;
