"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateViewBuilder = exports.CreateView = void 0;
const statement_1 = require("../statement");
class CreateView extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.CREATE_VIEW;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isCreateView(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.CREATE_VIEW);
    }
    as(select) {
        this.$body = select;
        return this;
    }
}
exports.CreateView = CreateView;
function CreateViewBuilder(name) {
    return new CreateView(name);
}
exports.CreateViewBuilder = CreateViewBuilder;
CreateViewBuilder.ifNotExists = function (name) {
    const statement = CreateViewBuilder(name);
    statement.$behavior = 'CREATE_IF_NOT_EXISTS';
    return statement;
};
