"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropDatabaseBuilder = exports.DropDatabase = void 0;
const statement_1 = require("../statement");
class DropDatabase extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_DATABASE;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$behavior = 'DROP';
        this.$name = name;
    }
    static isDropDatabase(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_DATABASE);
    }
}
exports.DropDatabase = DropDatabase;
function DropDatabaseBuilder(name) {
    return new DropDatabase(name);
}
exports.DropDatabaseBuilder = DropDatabaseBuilder;
DropDatabaseBuilder.ifExists = function (name) {
    const statement = DropDatabaseBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
