"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropFunctionBuilder = exports.DropFunction = void 0;
const statement_1 = require("../statement");
class DropFunction extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_FUNCTION;
        this.$behavior = 'DROP';
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isDropFunction(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_FUNCTION);
    }
}
exports.DropFunction = DropFunction;
function DropFunctionBuilder(name) {
    return new DropFunction(name);
}
exports.DropFunctionBuilder = DropFunctionBuilder;
DropFunctionBuilder.ifExists = function (name) {
    const statement = DropFunctionBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
