"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropProcedureBuilder = exports.DropProcedure = void 0;
const statement_1 = require("../statement");
class DropProcedure extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_PROCEDURE;
        this.$behavior = 'DROP';
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isDropProcedure(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_PROCEDURE);
    }
}
exports.DropProcedure = DropProcedure;
function DropProcedureBuilder(name) {
    return new DropProcedure(name);
}
exports.DropProcedureBuilder = DropProcedureBuilder;
DropProcedureBuilder.ifExists = function (name) {
    const statement = DropProcedureBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
