"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropSchemaBuilder = exports.DropSchema = void 0;
const statement_1 = require("../statement");
class DropSchema extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_SCHEMA;
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$behavior = 'DROP';
        this.$name = name;
    }
    static isDropSchema(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_SCHEMA);
    }
}
exports.DropSchema = DropSchema;
function DropSchemaBuilder(name) {
    return new DropSchema(name);
}
exports.DropSchemaBuilder = DropSchemaBuilder;
DropSchemaBuilder.ifExists = function (name) {
    const statement = DropSchemaBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
