"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropSequenceBuilder = exports.DropSequence = void 0;
const statement_1 = require("../statement");
class DropSequence extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_SEQUENCE;
        this.$behavior = 'DROP';
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isDropSequence(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_SEQUENCE);
    }
}
exports.DropSequence = DropSequence;
function DropSequenceBuilder(name) {
    return new DropSequence(name);
}
exports.DropSequenceBuilder = DropSequenceBuilder;
DropSequenceBuilder.ifExists = function (name) {
    const statement = DropSequenceBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
