import { XObjectName } from '../../object';
import { Statement, STATEMENT_KIND, STATEMENT_TAG } from '../statement';
import { DropBehavior } from './types';
export declare class DropTable<N extends string = string> extends Statement {
    static isDropTable(object: any): object is DropTable;
    $kind: STATEMENT_KIND.DROP_TABLE;
    $name: XObjectName<N>;
    $behavior: DropBehavior;
    $tag: STATEMENT_TAG.EXECUTABLE;
    constructor(name: XObjectName<N>);
}
export declare function DropTableBuilder(name: XObjectName): DropTable;
export declare namespace DropTableBuilder {
    var ifExists: (name: XObjectName<string>) => DropTable<string>;
}
export declare type DropTableBuilder = typeof DropTableBuilder;
