"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropTableBuilder = exports.DropTable = void 0;
const statement_1 = require("../statement");
class DropTable extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_TABLE;
        this.$behavior = 'DROP';
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isDropTable(object) {
        return (statement_1.Statement.isStatement(object) &&
            object.$kind === statement_1.STATEMENT_KIND.DROP_TABLE);
    }
}
exports.DropTable = DropTable;
function DropTableBuilder(name) {
    return new DropTable(name);
}
exports.DropTableBuilder = DropTableBuilder;
DropTableBuilder.ifExists = function (name) {
    const statement = DropTableBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
