"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropViewBuilder = exports.DropView = void 0;
const statement_1 = require("../statement");
class DropView extends statement_1.Statement {
    constructor(name) {
        super();
        this.$kind = statement_1.STATEMENT_KIND.DROP_VIEW;
        this.$behavior = 'DROP';
        this.$tag = statement_1.STATEMENT_TAG.EXECUTABLE;
        this.$name = name;
    }
    static isDropView(object) {
        return (statement_1.Statement.isStatement(object) && object.$kind === statement_1.STATEMENT_KIND.DROP_VIEW);
    }
}
exports.DropView = DropView;
function DropViewBuilder(name) {
    return new DropView(name);
}
exports.DropViewBuilder = DropViewBuilder;
DropViewBuilder.ifExists = function (name) {
    const statement = DropViewBuilder(name);
    statement.$behavior = 'DROP_IF_EXISTS';
    return statement;
};
