"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForeignKey = void 0;
const sql_1 = require("../../sql");
class ForeignKey extends sql_1.Sql {
    constructor(name, columns) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.FOREIGN_KEY;
        this.$name = name;
        if (columns) {
            this.on(columns);
        }
    }
    static isForeignKey(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.FOREIGN_KEY;
    }
    on(...columns) {
        if (columns.length === 1 && Array.isArray(columns[0])) {
            columns = columns[0];
        }
        this.$columns = columns;
        return this;
    }
    reference(table, columns) {
        this.$referenceTable = table;
        this.$referenceColumns = columns;
        return this;
    }
    deleteCascade() {
        this.$deleteCascade = true;
        return this;
    }
}
exports.ForeignKey = ForeignKey;
