"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UniqueKey = void 0;
const sql_1 = require("../../sql");
/**
 * 唯一约束
 */
class UniqueKey extends sql_1.Sql {
    constructor(name, columns) {
        super();
        this.$type = sql_1.SQL_SYMBOLE.UNIQUE_KEY;
        this.$name = name;
        if (columns) {
            this.on(columns);
        }
    }
    static isUniqueKey(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.UNIQUE_KEY;
    }
    on(columns) {
        if (this.$columns) {
            throw new Error(`Columns is defined.`);
        }
        if (Array.isArray(columns)) {
            if (columns.length === 0) {
                throw new Error(`Primary key must have a column.`);
            }
            if (typeof columns[0] === 'string') {
                this.$columns = columns.map(name => ({
                    name,
                    sort: 'ASC',
                }));
            }
            else {
                this.$columns = columns;
            }
            return this;
        }
        this.$columns = Object.entries(columns).map(([name, sort]) => ({
            name,
            sort,
        }));
        return this;
    }
}
exports.UniqueKey = UniqueKey;
