"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Statement = exports.STATEMENT_TAG = exports.STATEMENT_KIND = void 0;
const sql_1 = require("../sql");
var STATEMENT_KIND;
(function (STATEMENT_KIND) {
    // RAW = 'RAW',
    STATEMENT_KIND["SELECT"] = "SELECT";
    STATEMENT_KIND["UPDATE"] = "UPDATE";
    STATEMENT_KIND["INSERT"] = "INSERT";
    STATEMENT_KIND["EXECUTE"] = "EXECUTE";
    STATEMENT_KIND["DELETE"] = "DELETE";
    STATEMENT_KIND["ASSIGNMENT"] = "ASSIGNMENT";
    STATEMENT_KIND["CREATE_TABLE"] = "CREATE_TABLE";
    STATEMENT_KIND["CREATE_PROCEDURE"] = "CREATE_PROCEDURE";
    STATEMENT_KIND["CREATE_FUNCTION"] = "CREATE_FUNCTION";
    STATEMENT_KIND["CREATE_INDEX"] = "CREATE_INDEX";
    STATEMENT_KIND["CREATE_VIEW"] = "CREATE_VIEW";
    STATEMENT_KIND["ALTER_PROCEDURE"] = "ALTER_PROCEDURE";
    STATEMENT_KIND["ALTER_VIEW"] = "ALTER_VIEW";
    STATEMENT_KIND["ALTER_FUNCTION"] = "ALTER_FUNCTION";
    STATEMENT_KIND["ALTER_TABLE"] = "ALTER_TABLE";
    STATEMENT_KIND["DROP_VIEW"] = "DROP_VIEW";
    STATEMENT_KIND["DROP_FUNCTION"] = "DROP_FUNCETION";
    STATEMENT_KIND["DROP_PROCEDURE"] = "DROP_PROCEDURE";
    STATEMENT_KIND["DROP_TABLE"] = "DROP_TABLE";
    STATEMENT_KIND["DROP_INDEX"] = "DROP_INDEX";
    STATEMENT_KIND["BLOCK"] = "BLOCK";
    STATEMENT_KIND["STANDARD_STATEMENT"] = "STANDARD_STATEMENT";
    STATEMENT_KIND["CREATE_SEQUENCE"] = "CREATE_SEQUENCE";
    STATEMENT_KIND["DROP_SEQUENCE"] = "DROP_SEQUENCE";
    STATEMENT_KIND["ANNOTATION"] = "ANNOTATION";
    STATEMENT_KIND["IF"] = "IF";
    STATEMENT_KIND["WHILE"] = "WHILE";
    STATEMENT_KIND["BREAK"] = "BREAK";
    STATEMENT_KIND["CONTINUE"] = "CONTINUE";
    STATEMENT_KIND["DROP_DATABASE"] = "DROP_DATABASE";
    STATEMENT_KIND["CREATE_DATABASE"] = "CREATE_DATABASE";
    STATEMENT_KIND["CREATE_SCHEMA"] = "CREATE_SCHEMA";
    STATEMENT_KIND["DROP_SCHEMA"] = "DROP_SCHEMA";
    STATEMENT_KIND["ALTER_DATABASE"] = "ALTER_DATABASE";
    STATEMENT_KIND["USE"] = "USE";
    STATEMENT_KIND["RETURN"] = "RETURN";
})(STATEMENT_KIND = exports.STATEMENT_KIND || (exports.STATEMENT_KIND = {}));
var STATEMENT_TAG;
(function (STATEMENT_TAG) {
    // 控制编程语句，需要放到存储过程内部中执行(MSSQL除外)
    STATEMENT_TAG["CONTROL"] = "CONTROL";
    // 可执行语句
    STATEMENT_TAG["EXECUTABLE"] = "EXECUTABLE";
})(STATEMENT_TAG = exports.STATEMENT_TAG || (exports.STATEMENT_TAG = {}));
/**
 * SQL 语句
 */
class Statement extends sql_1.Sql {
    constructor() {
        super(...arguments);
        this.$type = sql_1.SQL_SYMBOLE.STATEMENT;
    }
    static isStatement(object) {
        return object?.$type === sql_1.SQL_SYMBOLE.STATEMENT;
    }
}
exports.Statement = Statement;
