"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clone = void 0;
function clone(value) {
    if (Array.isArray(value)) {
        return value.map(item => clone(item));
    }
    if (value && typeof value === 'object') {
        const copied = {};
        Object.entries(value).forEach(([k, v]) => {
            copied[k] = clone(v);
        });
        Object.setPrototypeOf(copied, Object.getPrototypeOf(value));
        return copied;
    }
    return value;
}
exports.clone = clone;
// export function isPlainObject(object: any): object is Object {
//   const proto = Object.getPrototypeOf(object);
//   return proto === Object.prototype || proto === null;
// }
