import { MigrateScripter } from './migrate-scripter';
import { ColumnSchema, ConstraintSchema, DatabaseSchema, ForeignKeySchema, IndexSchema, PrimaryKeySchema, SequenceSchema, TableSchema } from './schema';
import { XObjectName, Sqlifier } from '../core';
import { SchemaComparator } from './schema-comparator';
export declare class CodeMigrateScripter extends MigrateScripter<string> {
    private sqlifier;
    private notResolverType;
    constructor(comparator: SchemaComparator, sqlifier: Sqlifier, notResolverType?: boolean);
    annotation(note: string): void;
    alterDatabase(database: DatabaseSchema): void;
    commentColumn(table: XObjectName<string>, name: string, comment?: string): void;
    commentTable(table: XObjectName<string>, comment?: string): void;
    commentIndex(table: XObjectName<string>, name: string, comment?: string): void;
    commentConstraint(table: XObjectName<string>, name: string, comment?: string): void;
    commentForeignKey(table: XObjectName<string>, name: string, comment?: string): void;
    private stringifyType;
    private columnForAlter;
    private columnForAdd;
    private keyColumns;
    private primaryKey;
    private foreignKey;
    private constraint;
    private checkConstraint;
    createTable(table: TableSchema): void;
    namify(objName: XObjectName): string;
    dropPrimaryKey(table: XObjectName<string>, name: string): void;
    dropTable(table: TableSchema): void;
    dropColumn(table: XObjectName, column: string): void;
    setAutoRowflag(table: XObjectName<string>, column: string): void;
    dropAutoRowflag(table: XObjectName<string>, column: string): void;
    dropConstraint(table: XObjectName, constraint: ConstraintSchema): void;
    addColumn(table: XObjectName, column: ColumnSchema): void;
    alterColumn(table: XObjectName, column: ColumnSchema): void;
    setDefaultValue(table: XObjectName, column: string, defaultValue: string): void;
    dropDefaultValue(table: XObjectName, column: string): void;
    setIdentity(table: XObjectName, column: string, startValue: number, increment: number): void;
    dropIdentity(table: XObjectName, column: string): void;
    addForeignKey(table: XObjectName, fk: ForeignKeySchema): void;
    dropForeignKey(table: XObjectName, name: string): void;
    addConstraint(table: XObjectName, constaint: ConstraintSchema): void;
    addPrimaryKey(table: XObjectName, key: PrimaryKeySchema): void;
    createSequence(sequence: SequenceSchema): void;
    dropSequence(sequence: SequenceSchema): void;
    createIndex(table: XObjectName<string>, index: IndexSchema): void;
    dropIndex(table: XObjectName<string>, name: string): void;
    comment(type: 'Table' | 'Procedure' | 'Function' | 'Schema', object: XObjectName<string>, comment?: string): void;
    comment(type: 'Column' | 'Constraint' | 'Index', table: XObjectName<string>, member: string, comment?: string): void;
    insertSeedData(table: TableSchema, data: any[]): void;
    createDatabase(database: DatabaseSchema): void;
    dropDatabase(name: string): void;
}
