export declare type CompareScalarType = undefined | null | string | number | boolean | Date | bigint | CompareScalarType[];
export declare type CompareListType = object[];
export declare type CompareObjectType = object;
export declare type ScalarDifference<T extends CompareScalarType> = {
    source: T | null | undefined;
    target: T | null | undefined;
};
export declare type ObjectDifference<T extends object> = {
    source: T | undefined;
    target: T | undefined;
    added?: T;
    removed?: T;
    changes?: {
        [P in keyof T]?: T[P] extends CompareScalarType | CompareScalarType[] ? ScalarDifference<T[P]> : T[P] extends (infer M)[] ? NonNullable<M> extends object ? ListDifference<NonNullable<M>> : never : NonNullable<T[P]> extends object ? ObjectDifference<NonNullable<T[P]>> : never;
    };
};
export declare type ListDifference<T extends object> = {
    source: T[] | undefined;
    target: T[] | undefined;
    addeds: T[];
    removeds: T[];
    changes: ObjectDifference<T>[];
};
export declare enum ValueType {
    scalar = 0,
    object = 1,
    list = 2
}
export declare function isListType(value: any): value is CompareListType;
export declare function isCompareScalarType(value: any): value is CompareScalarType;
export declare function isObejctType(value: any): value is CompareObjectType;
export declare function getType(value: any): ValueType;
/**
 * 对比标量类型值是否相同
 * @param source
 * @param target
 * @returns
 */
export declare function compareScalar<T extends CompareScalarType>(source: T | null | undefined, target: T | null | undefined, equalsComparator?: (left: CompareScalarType, right: CompareScalarType, path: string) => boolean | undefined, path?: string): ScalarDifference<T> | null;
export declare function compareObject<T extends object>(source: T | undefined, target: T | undefined, isKeyEquals?: ObjectKeyCompartor, isEquals?: EqulsCompartor, path?: string): ObjectDifference<T> | null;
/**
 * 用于确定是否同一对象
 */
export declare type ObjectKeyCompartor = (left: any, right: any, path: string) => boolean;
export declare type EqulsCompartor = (left: any, right: any, path: string) => boolean | undefined;
export declare function compareList<T extends object>(source: T[] | undefined, target: T[] | undefined, isKeyEquals: ObjectKeyCompartor, isEquals?: EqulsCompartor, path?: string): ListDifference<T> | null;
export declare type CompareResult<T> = T extends CompareScalarType ? ScalarDifference<T> : T extends (infer E)[] ? E extends object ? ListDifference<E> : never : T extends object ? ObjectDifference<T> : never;
