"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MigrateBuilder = void 0;
const core_1 = require("../core");
class MigrateBuilder {
    // use(name: string): Statement {
    //   return SQL.use(name);
    // }
    // alterDatabase(name: string): AlterDatabase {
    //   return SQL.alterDatabase(name);
    // }
    // createDatabase(name: string): CreateDatabase {
    //   return SQL.createDatabase(name);
    // }
    // dropDatabase(name: string): DropDatabase {
    //   return SQL.dropDatabase(name);
    // }
    sql(statement) {
        return core_1.Statement.isStatement(statement) ? statement : core_1.SQL.raw(statement);
    }
    createTable(name) {
        return core_1.SQL.createTable(name);
    }
    alterTable(name) {
        return core_1.SQL.alterTable(name);
    }
    dropTable(name) {
        return core_1.SQL.dropTable(name);
    }
    createView(name) {
        return core_1.SQL.createView(name);
    }
    alterView(name) {
        return core_1.SQL.alterView(name);
    }
    dropView(name) {
        return core_1.SQL.dropView(name);
    }
    createProcedure(name) {
        return core_1.SQL.createProcedure(name);
    }
    alterProcedure(name) {
        return core_1.SQL.alterProcedure(name);
    }
    dropProcedure(name) {
        return core_1.SQL.dropProcedure(name);
    }
    createFunction(name) {
        return core_1.SQL.createFunction(name);
    }
    alterFunction(name) {
        return core_1.SQL.alterFunction(name);
    }
    dropFunction(name) {
        return core_1.SQL.dropFunction(name);
    }
    createSequence(name) {
        return core_1.SQL.createSequence(name);
    }
    createIndex(name) {
        return core_1.SQL.createIndex(name);
    }
    dropIndex(table, name) {
        return core_1.SQL.dropIndex(table, name);
    }
    dropSequence(name) {
        return core_1.SQL.dropSequence(name);
    }
    insert(table, fields) {
        return core_1.SQL.insert(table, fields);
    }
    /**
     * 更新一个表格
     * @param table
     */
    update(table) {
        return core_1.SQL.update(table);
    }
    /**
     * 删除一个表格
     * @param table 表格
     */
    delete(table) {
        return core_1.SQL.delete(table);
    }
}
exports.MigrateBuilder = MigrateBuilder;
