import { MigrateBuilder } from './migrate-builder';
import { ExecutableStatement, XObjectName } from '../core';
import { MigrateScripter } from './migrate-scripter';
import { ColumnSchema, ConstraintSchema, ForeignKeySchema, IndexSchema, PrimaryKeySchema, SequenceSchema, TableSchema } from './schema';
import { SchemaComparator } from './schema-comparator';
export declare class SqlMigrateScripter extends MigrateScripter<ExecutableStatement> {
    private readonly builder;
    constructor(comparator: SchemaComparator, builder: MigrateBuilder);
    annotation(note: string): void;
    createTable(table: TableSchema): void;
    dropTable(table: TableSchema): void;
    insertSeedData(table: TableSchema, data: any[]): void;
    createIndex(table: XObjectName, index: IndexSchema): void;
    dropIndex(table: XObjectName, name: string): void;
    addForeignKey(table: XObjectName, fk: ForeignKeySchema): void;
    dropForeignKey(table: XObjectName, name: string): void;
    commentColumn(table: XObjectName<string>, name: string, comment?: string): void;
    commentTable(table: XObjectName, comment?: string): void;
    commentIndex(table: XObjectName, name: string, comment?: string): void;
    commentConstraint(table: XObjectName, name: string, comment?: string): void;
    commentForeignKey(table: XObjectName, name: string, comment?: string): void;
    setDefaultValue(table: XObjectName, column: string, defaultValue: string): void;
    dropDefaultValue(table: XObjectName, column: string): void;
    setAutoRowflag(table: XObjectName, column: string): void;
    dropAutoRowflag(table: XObjectName, column: string): void;
    dropIdentity(table: XObjectName, column: string): void;
    setIdentity(table: XObjectName, column: string, start: number, increment: number): void;
    createSequence(sequence: SequenceSchema): void;
    dropSequence(name: SequenceSchema): void;
    addColumn(table: XObjectName, schema: ColumnSchema): void;
    dropColumn(table: XObjectName, name: string): void;
    alterColumn(table: XObjectName, column: ColumnSchema): void;
    addPrimaryKey(table: XObjectName, pk: PrimaryKeySchema): void;
    dropPrimaryKey(table: XObjectName, name: string): void;
    addConstraint(table: XObjectName, constraint: ConstraintSchema): void;
    dropConstraint(table: XObjectName, constraint: ConstraintSchema): void;
    private tableColumnForAlter;
    private tableColumnForAdd;
}
