"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isListType = exports.isJsonType = exports.isBaseType = void 0;
const core_1 = require("../core");
function isBaseType(type) {
    return (type === String ||
        type === Number ||
        type === Boolean ||
        type === Date ||
        type === core_1.Decimal ||
        type === core_1.Uuid ||
        type === BigInt ||
        type === Buffer ||
        type === ArrayBuffer ||
        type === SharedArrayBuffer);
}
exports.isBaseType = isBaseType;
function isJsonType(type) {
    return !isBaseType(type);
}
exports.isJsonType = isJsonType;
function isListType(type) {
    return Array.isArray(type) && isBaseType(type[0]);
}
exports.isListType = isListType;
