import { Connection, ConnectOptions } from '../core/base/connection';
import { DbContext, DbContextConstructor } from './db-context';
/**
 * 创建默认DbContext，其值为已注册的默认context类实例
 * 如未有注册Context则抛出异常
 */
export declare function createContext(): Promise<DbContext>;
/**
 * 通过配置创建一个DbContext，其值为已注册的默认context类实例
 * 如未有注册Context则抛出异常
 */
export declare function createContext(optOrCfgOrUrlOrLube?: ConnectOptions | string | Connection): Promise<DbContext>;
export declare function createContext<T extends DbContext>(Ctr: DbContextConstructor<T>, optOrCfgOrUrlOrLube?: Connection | ConnectOptions | string): Promise<T>;
