"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = void 0;
const connection_1 = require("../core/base/connection");
const config_1 = require("../core/config");
const core_1 = require("../core");
const metadata_store_1 = require("./metadata-store");
async function createContext(optOrCfgOrUrlOrLubeOrCtr, optOrCfgOrUrlOrLube) {
    // if (typeof Ctr === 'function' && optOrUrlOrLube instanceof Lube) return Ctr(optOrUrlOrLube);
    let Ctr;
    let lube;
    if (!optOrCfgOrUrlOrLubeOrCtr) {
        Ctr = metadata_store_1.metadataStore.defaultContext.class;
        const options = await getConnectOptions(Ctr);
        // if (!options) {
        //   throw new Error(`Context ${Ctr.name} 's config not found in configure file, pls configure it or provider options.`)
        // }
        lube = await (0, core_1.createConnection)(options);
    }
    else if (typeof optOrCfgOrUrlOrLubeOrCtr === 'function') {
        Ctr = optOrCfgOrUrlOrLubeOrCtr;
        if (!optOrCfgOrUrlOrLube) {
            const options = await getConnectOptions(Ctr);
            lube = await (0, core_1.createConnection)(options);
        }
        else if (optOrCfgOrUrlOrLube instanceof connection_1.Connection) {
            lube = optOrCfgOrUrlOrLube;
        }
        else {
            const options = await getConnectOptions(optOrCfgOrUrlOrLube);
            lube = await (0, core_1.createConnection)(options);
        }
    }
    else if (optOrCfgOrUrlOrLubeOrCtr instanceof connection_1.Connection) {
        Ctr = metadata_store_1.metadataStore.defaultContext.class;
        lube = optOrCfgOrUrlOrLubeOrCtr;
    }
    else {
        Ctr = metadata_store_1.metadataStore.defaultContext.class;
        const options = await getConnectOptions(optOrCfgOrUrlOrLubeOrCtr);
        lube = await (0, core_1.createConnection)(options);
    }
    return new Ctr(lube);
}
exports.createContext = createContext;
async function getConnectOptions(opt) {
    let options;
    if (typeof opt === 'function') {
        const config = await (0, config_1.loadConfig)();
        options = config.connections[opt.name];
        if (!options) {
            options = metadata_store_1.metadataStore.getContext(opt).connection;
        }
        if (!options) {
            throw new Error(`Option ${opt.name} not found in configure file.`);
        }
    }
    else {
        options = await (0, config_1.parseConnectOption)(opt);
    }
    return options;
}
