import { DbContextConstructor } from "./db-context";
import { DbContextMetadata, EntityMetadata } from "./metadata";
import { EntityType } from "./data-types";
/**********************************装饰器声明*************************************/
export declare class MetadataStore {
    private entityMap;
    private contextMap;
    private _defaultContext?;
    /**
     * 默认DbContext元数据
     */
    get defaultContext(): DbContextMetadata;
    /**
     * 可以通过实体构造函数/实体名称 获取已注册的元数据
     */
    getEntity(entityClass: EntityType): EntityMetadata;
    /**
     * 注册一个实体
     */
    registerEntity(metadata: EntityMetadata): this;
    /**
     * 获取上下文无数据
     */
    getContext(name: string): DbContextMetadata;
    getContext(contextClass: DbContextConstructor): DbContextMetadata;
    getContext(nameOrClass: DbContextConstructor | string): DbContextMetadata;
    /**
     * 注册上下文
     */
    registerContext(metadata: DbContextMetadata): this;
}
/**
 * 公共元数据存储
 */
export declare const metadataStore: MetadataStore;
