import { Entity, EntityConstructor } from '../entity';
import { DbContextConstructor } from '../db-context';
import { ConnectOptions } from '../../core';
import { EntityMetadata } from './entity-metadata';
import { KeyMetadata } from './key-metadata';
export declare class DbContextMetadata {
    constructor(ctr: DbContextConstructor);
    class: DbContextConstructor;
    database: string;
    className: string;
    globalKey?: KeyMetadata;
    /**
     * 连接
     */
    connection?: ConnectOptions;
    private _entitiyMap;
    private _entities;
    get entities(): ReadonlyArray<EntityMetadata>;
    /**
     * 摘要说明
     */
    comment?: string;
    /**
     * 获取实体元数据
     * @param ctr 实体构造函数
     */
    getEntity(ctr: EntityConstructor<Entity>): EntityMetadata | undefined;
    findEntityByName(name: string): EntityMetadata | undefined;
    /**
     *
     */
    findTableEntityByName(tableName: string): EntityMetadata | undefined;
    addEntity(entity: EntityMetadata): this;
}
