"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DbContextMetadata = void 0;
const util_1 = require("./util");
class DbContextMetadata {
    constructor(ctr) {
        this._entitiyMap = new Map();
        this._entities = [];
        this.class = ctr;
    }
    get entities() {
        return this._entities;
    }
    /**
     * 获取实体元数据
     * @param ctr 实体构造函数
     */
    getEntity(ctr) {
        return this._entitiyMap.get(ctr);
    }
    findEntityByName(name) {
        return this.entities.find(entity => entity.className === name);
    }
    /**
     *
     */
    findTableEntityByName(tableName) {
        return this.entities.find(entity => (0, util_1.isTableEntity)(entity) && entity.dbName === tableName);
    }
    addEntity(entity) {
        if (this._entitiyMap.has(entity.class)) {
            throw new Error(`Entity ${entity.className} is exists in DbContext.`);
        }
        this._entitiyMap.set(entity.class, entity);
        this._entities.push(entity);
        return this;
    }
}
exports.DbContextMetadata = DbContextMetadata;
