import { Entity } from '../entity';
import { HasManyMetadata } from '../metadata';
import { ContextBuilder } from './context-builder';
import { EntityBuilder } from './entity-builder';
import { ManyToManyBuilder } from './many-to-many-builder';
import { OneToManyBuilder } from './one-to-many-builder';
export declare class HasManyBuilder<S extends Entity, D extends Entity> {
    private readonly contextBuilder;
    private readonly entityBuilder;
    readonly metadata: Partial<HasManyMetadata>;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: Partial<HasManyMetadata>);
    private assertWith;
    withOne(selector?: (p: Required<D>) => S): OneToManyBuilder<S, D>;
    withMany(selector?: (p: Required<D>) => S[]): ManyToManyBuilder<S, D>;
}
