import { Entity } from "../entity";
import { HasOneMetadata } from "../metadata";
import { ContextBuilder } from "./context-builder";
import { EntityBuilder } from "./entity-builder";
import { ManyToOneBuilder } from "./one-to-many-builder";
import { OneToOneMapBuilder } from "./one-to-one-map-builder";
export declare class HasOneBuilder<S extends Entity, D extends Entity> {
    private contextBuilder;
    private entityBuilder;
    readonly metadata: Partial<HasOneMetadata>;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: Partial<HasOneMetadata>);
    private assertWith;
    withOne(selector?: (p: Required<D>) => S): OneToOneMapBuilder<S, D>;
    withMany(selector?: (p: Required<D>) => S[]): ManyToOneBuilder<S, D>;
}
