import { Scalar } from "../../core";
import { Entity } from "../entity";
import { IndexMetadata } from "../metadata";
import { ContextBuilder } from "./context-builder";
import { EntityBuilder } from "./entity-builder";
export declare class IndexBuilder<T extends Entity> {
    readonly metadata: IndexMetadata;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<T>, metadata: IndexMetadata);
    hasName(name: string): this;
    isUnique(unique: false): this;
    isUnique(unique: true, clustered: boolean): this;
    isUnique(unique?: boolean): this;
    hasComment(comment: string): this;
    withProperties(selector: {
        [K in keyof T]?: 'ASC' | 'DESC';
    } | ((p: Required<T>) => Scalar[])): this;
}
