"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndexBuilder = void 0;
const util_1 = require("../util");
class IndexBuilder {
    constructor(contextBuilder, entityBuilder, metadata) {
        this.metadata = metadata;
    }
    hasName(name) {
        this.metadata.name = name;
        return this;
    }
    isUnique(unique = true, clustered) {
        this.metadata.isUnique = unique;
        if (unique) {
            this.metadata.isClustered = clustered;
        }
        else {
            this.metadata.isClustered = false;
        }
        return this;
    }
    // isClustered(clustered: boolean = true): this {
    //   this.metadata.isClustered = clustered;
    //   return this;
    // }
    hasComment(comment) {
        this.metadata.comment = comment;
        return this;
    }
    // withProperties(selector: (p: Required<T>) => Scalar[]): this;
    // withProperties(selector: { [K in keyof T]?: 'ASC' | 'DESC' }): this;
    withProperties(selector) {
        this.metadata.properties =
            typeof selector === 'function' ? (0, util_1.selectProperty)(selector) : selector;
        return this;
    }
}
exports.IndexBuilder = IndexBuilder;
