import { Entity, EntityConstructor } from "../entity";
import { ManyToManyMetadata } from "../metadata";
import { ContextBuilder } from "./context-builder";
import { EntityBuilder } from "./entity-builder";
export declare class ManyToManyBuilder<S extends Entity, D extends Entity> {
    private readonly contextBuilder;
    private readonly entityBuilder;
    readonly metadata: ManyToManyMetadata;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: ManyToManyMetadata);
    /**
     * 显式声明关系中间表
     * 仅要一方声明中间表即可，无须双方声明
     */
    hasRelationTable<T extends Entity>(ctr: EntityConstructor<T>, 
    /**
     * 中间表导航属性
     */
    relationPropertySelector?: (p: Required<S>) => T[], build?: (builder: EntityBuilder<T>) => void): EntityBuilder<T>;
    isDetail(yesOrNo?: boolean): this;
    /**
     * 指定约束名称
     */
    hasConstraintName(name: string): this;
}
