"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManyToManyBuilder = void 0;
const util_1 = require("../util");
class ManyToManyBuilder {
    constructor(contextBuilder, entityBuilder, metadata) {
        this.contextBuilder = contextBuilder;
        this.entityBuilder = entityBuilder;
        this.metadata = metadata;
    }
    /**
     * 显式声明关系中间表
     * 仅要一方声明中间表即可，无须双方声明
     */
    hasRelationTable(ctr, 
    /**
     * 中间表导航属性
     */
    relationPropertySelector, build) {
        if (relationPropertySelector) {
            this.metadata.relationProperty = (0, util_1.selectProperty)(relationPropertySelector);
        }
        const builder = this.contextBuilder.entity(ctr);
        if (build) {
            build(builder);
        }
        this.metadata.relationClass = ctr;
        this.metadata.relationEntity = builder.metadata;
        if (this.metadata.referenceProperty) {
            const referenceRelation = this.metadata.referenceEntity.getRelation(this.metadata.referenceProperty);
            if (referenceRelation) {
                if (referenceRelation.relationClass && referenceRelation.relationClass !== ctr) {
                    throw new Error(`Duplicate relation entity declare on may to many relation.`);
                }
                referenceRelation.relationClass = ctr;
                referenceRelation.relationEntity = this.metadata.relationEntity;
            }
        }
        return builder;
    }
    isDetail(yesOrNo = true) {
        this.metadata.isDetail = yesOrNo;
        return this;
    }
    /**
     * 指定约束名称
     */
    hasConstraintName(name) {
        this.metadata.relationConstraintName = name;
        return this;
    }
}
exports.ManyToManyBuilder = ManyToManyBuilder;
