import { Scalar } from '../../core';
import { Entity } from '../entity';
import { OneToManyMetadata, ManyToOneMetadata } from '../metadata';
import { ContextBuilder } from './context-builder';
import { EntityBuilder } from './entity-builder';
export declare class OneToManyBuilder<S extends Entity, D extends Entity> {
    private readonly contextBuilder;
    private readonly entityBuilder;
    readonly metadata: OneToManyMetadata;
    isDetail(yesOrNo?: boolean): this;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: OneToManyMetadata);
}
export declare class ManyToOneBuilder<S extends Entity, D extends Entity> {
    private readonly contextBuilder;
    private readonly entityBuilder;
    readonly metadata: ManyToOneMetadata;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: ManyToOneMetadata);
    hasConstraintName(name: string): void;
    /**
     * 声明外键属性
     * @param selector
     * @returns
     */
    hasForeignKey<P extends Scalar>(selector: (p: Required<S>) => P): this;
    isRequired(): this;
    isCascade(): Omit<this, 'isCascade'>;
    hasComment(comment: string): Omit<this, 'hasComment'>;
}
