"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManyToOneBuilder = exports.OneToManyBuilder = void 0;
const util_1 = require("../util");
class OneToManyBuilder {
    constructor(contextBuilder, entityBuilder, metadata) {
        this.contextBuilder = contextBuilder;
        this.entityBuilder = entityBuilder;
        this.metadata = metadata;
    }
    isDetail(yesOrNo = true) {
        this.metadata.isDetail = yesOrNo;
        return this;
    }
}
exports.OneToManyBuilder = OneToManyBuilder;
class ManyToOneBuilder {
    constructor(contextBuilder, entityBuilder, metadata) {
        this.contextBuilder = contextBuilder;
        this.entityBuilder = entityBuilder;
        this.metadata = metadata;
    }
    hasConstraintName(name) {
        this.metadata.constraintName = name;
    }
    /**
     * 声明外键属性
     * @param selector
     * @returns
     */
    hasForeignKey(selector) {
        if (selector) {
            const property = (0, util_1.selectProperty)(selector);
            if (!property)
                throw new Error(`Please select a property.`);
            this.metadata.foreignProperty = property;
            // const foreingColumn = this.entityBuilder.metadata.getColumn(property);
            // if (!foreingColumn) {
            //   this.entityBuilder.column(property, );
            //   this.metadata.foreignColumn = this.entityBuilder.column(property);
            // }
        }
        return this;
    }
    isRequired() {
        this.metadata.isRequired = true;
        return this;
    }
    isCascade() {
        this.metadata.isCascade = true;
        return this;
    }
    hasComment(comment) {
        this.metadata.comment = comment;
        return this;
    }
}
exports.ManyToOneBuilder = ManyToOneBuilder;
