"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForeignOneToOneBuilder = exports.PrimaryOneToOneBuilder = exports.OneToOneBuilder = void 0;
class OneToOneBuilder {
    constructor(contextBuilder, entityBuilder, metadata) {
        this.contextBuilder = contextBuilder;
        this.entityBuilder = entityBuilder;
        this.metadata = metadata;
    }
    hasComment(comment) {
        this.metadata.comment = comment;
        return this;
    }
}
exports.OneToOneBuilder = OneToOneBuilder;
class PrimaryOneToOneBuilder extends OneToOneBuilder {
    /**
     * 声明为明细项
     * 获取或查询时传递withDetail选项，将自动附带
     * 删除时亦将同步删除，默认为联动删除
     */
    isDetail(yesOrNo = true) {
        this.metadata.isDetail = yesOrNo;
        return this;
    }
}
exports.PrimaryOneToOneBuilder = PrimaryOneToOneBuilder;
class ForeignOneToOneBuilder extends OneToOneBuilder {
    hasConstraintName(name) {
        this.metadata.constraintName = name;
        return this;
    }
    isRequired(yesOrNo = true) {
        this.metadata.isRequired = yesOrNo;
        return this;
    }
    isCascade(yesOrNo = true) {
        this.metadata.isCascade = yesOrNo;
        return this;
    }
}
exports.ForeignOneToOneBuilder = ForeignOneToOneBuilder;
