import { Entity } from "../entity";
import { OneToOneMetadata } from "../metadata";
import { ContextBuilder } from "./context-builder";
import { EntityBuilder } from "./entity-builder";
import { PrimaryOneToOneBuilder, ForeignOneToOneBuilder } from "./one-to-one-builder";
export declare class OneToOneMapBuilder<S extends Entity, D extends Entity> {
    private readonly contextBuilder;
    private readonly entityBuilder;
    readonly metadata: OneToOneMetadata;
    constructor(contextBuilder: ContextBuilder, entityBuilder: EntityBuilder<S>, metadata: OneToOneMetadata);
    /**
     * 声明当前实体在一对一关系中占主键地位
     */
    isPrimary(): PrimaryOneToOneBuilder<S, D>;
    /**
     * 声明为一对一（从）关系，并指定外键属性
     * @param selector
     * @returns
     */
    hasForeignKey(selector?: (p: S) => D): ForeignOneToOneBuilder<S, D>;
    private assertPrimary;
}
