"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableKeyBuilder = void 0;
class TableKeyBuilder {
    constructor(entityBuilder, metadata) {
        this.entityBuilder = entityBuilder;
        this.metadata = metadata;
    }
    hasComment(comment) {
        this.entityBuilder.metadata.key.comment = comment;
        return this;
    }
    /**
     * 指定约束名称
     * @param constraintName
     * @returns
     */
    hasConstraintName(constraintName) {
        this.metadata.constraintName = constraintName;
        return this;
    }
    /**
     * 将主键声明为非聚焦
     * @returns
     */
    isNonclustered() {
        this.metadata.isNonclustered = true;
        return this;
    }
}
exports.TableKeyBuilder = TableKeyBuilder;
