/**
 * 当一个属性未定义时，为一个属性赋值
 * @param target
 * @param property
 * @param value
 * @returns
 */
export declare function assignProppertyIfUndefined<T extends object, P extends keyof T>(target: T, property: P, value: T[P]): boolean;
export declare function assignIfUndefined<T extends object>(dest: T, source: Partial<T>): void;
export declare type OverloadMatch<A extends []> = ((args: A) => boolean) | Function[];
export declare type OverloadFn<A extends [], R> = (...args: A) => R;
export declare function overload<A1 extends [], R1, A2 extends [], R2, A3 extends [] = never, R3 = never, A4 extends [] = never, R4 = never, A5 extends [] = never, R5 = never>(match1: OverloadMatch<A1>, fn1: OverloadFn<A1, R1>, match2: OverloadMatch<A2>, fn2: OverloadFn<A2, R2>, match3: OverloadMatch<A3>, fn3: OverloadFn<A3, R3>, match4: OverloadMatch<A4>, fn4: OverloadFn<A4, R4>, match5: OverloadMatch<A5>, fn5: OverloadFn<A5, R5>): {
    (...args: A1): R1;
    (...args: A2): R2;
    (...args: A3): R3;
    (...args: A4): R4;
    (...args: A5): R5;
};
export declare function overload<A1 extends [], R1, A2 extends [], R2, A3 extends [] = never, R3 = never, A4 extends [] = never, R4 = never>(match1: OverloadMatch<A1>, fn1: OverloadFn<A1, R1>, match2: OverloadMatch<A2>, fn2: OverloadFn<A2, R2>, match3: OverloadMatch<A3>, fn3: OverloadFn<A3, R3>, match4: OverloadMatch<A4>, fn4: OverloadFn<A4, R4>): {
    (...args: A1): R1;
    (...args: A2): R2;
    (...args: A3): R3;
    (...args: A4): R4;
};
export declare function overload<A1 extends [], R1, A2 extends [], R2, A3 extends [] = never, R3 = never>(match1: OverloadMatch<A1>, fn1: OverloadFn<A1, R1>, match2: OverloadMatch<A2>, fn2: OverloadFn<A2, R2>, match3: OverloadMatch<A3>, fn3: OverloadFn<A3, R3>): {
    (...args: A1): R1;
    (...args: A2): R2;
    (...args: A3): R3;
};
export declare function overload<A1 extends [], R1, A2 extends [], R2>(match1: OverloadMatch<A1>, fn1: OverloadFn<A1, R1>, match2: OverloadMatch<A2>, fn2: OverloadFn<A2, R2>): {
    (...args: A1): R1;
    (...args: A2): R2;
};
