"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.overload = exports.assignIfUndefined = exports.assignProppertyIfUndefined = void 0;
/**
 * 当一个属性未定义时，为一个属性赋值
 * @param target
 * @param property
 * @param value
 * @returns
 */
function assignProppertyIfUndefined(target, property, value) {
    if (target[property] === undefined || target[property] === null) {
        target[property] = value;
        return true;
    }
    return false;
}
exports.assignProppertyIfUndefined = assignProppertyIfUndefined;
function assignIfUndefined(dest, source) {
    for (const [key, value] of Object.entries(source)) {
        assignProppertyIfUndefined(dest, key, value);
    }
}
exports.assignIfUndefined = assignIfUndefined;
function overload(...options) {
    return function (...args) {
        function isMatch(match) {
            if (match.length > args.length)
                return false;
            for (let index = 0; index < match.length; index++) {
                const type = match[index];
                if (!(args[index] instanceof type) &&
                    args[index]?.constructor !== type) {
                    return false;
                }
            }
            return true;
        }
        let i = 0;
        let match;
        // eslint-disable-next-line no-cond-assign
        while ((match = options[i])) {
            const fn = options[++i];
            if (typeof fn !== 'function') {
                throw new Error(`Overload must special a function.`);
            }
            if (typeof match === 'function') {
                if (match(args)) {
                    return fn.call(this, ...args);
                }
            }
            else {
                if (isMatch(match)) {
                    return fn.call(this, ...args);
                }
            }
            i++;
        }
        throw new Error(`No overload matched by arugments.`);
    };
}
exports.overload = overload;
// export interface ExtraFunction {
//   /**
//    * 添加重载
//    */
//   overload<A extends [], R>(selector: (...args: A) => boolean, fn: (...args: A) => R): this & ((...args: A) => R);
// }
// export function q<D extends (...args: any) => any>(fn: D) {
//   return D & {
//     overload:
//   }
// }
